<?php
 namespace imwpf\modules; use imwpf\table; class Analysis { private $_table = null; private $_analysisUnit = null; public function __construct(table\AnalysisTable $ = null, AnalysisUnit $ = null) { if ($ == null) { $this->_table = new table\AnalysisTable(table\SQLiteConnection::get()); } else { $this->_table = $; } if ($ == null) { $this->_analysisUnit = new AnalysisUnit(new table\AnalysisUnitTable(table\SQLiteConnection::get())); } else { $this->_analysisUnit = $; } } public function initTable() { $this->_table->createTable(); $this->_analysisUnit->initTable(); } public function updateTable() { $this->_table->updateTable(); $this->_analysisUnit->updateTable(); } public function tableExists() { return $this->_table->tableExists() && $this->_analysisUnit->tableExists(); } public function record($, $, $ = null, $ = 1) { $ = $this->_analysisUnit->getSetUnitID($, $); if ($ === null) { $ = strtotime(date("Y-m-d H:00:00", time())); } $ = Spider::getCurrentSpiderID(); $this->_table->increment("num", $, "unit_id=:unit_id AND ua=:ua AND ts=:ts", array(":unit_id" => $, ":ua" => $, ":ts" => $)); } public function clear($) { return $this->_table->delete("ts<:ts", array(":ts" => $)); } public function getRange($, $) { $ = $this->_table->select("*", "ts >= :st AND ts < :et ORDER BY ts ASC", array(":st" => $, ":et" => $)); return $; } public function getRangeByName($, $, $) { $ = $this->_analysisUnit->getUnitID($); if ($ == 0) { return array(); } $ = $this->_table->select("*", "ts >= :st AND ts < :et AND unit_id=:unit_id ORDER BY ts ASC", array(":st" => $, ":et" => $, ":unit_id" => $)); return $; } public function getTodayByName($) { $ = utils\Time::wpStrToTime(wp_date("Y-m-d")); $ = time(); return $this->getRangeByName($, $, $); } public function getTodayCountByName($) { $ = $this->getTodayByName($); if (empty($)) { return 0; } return array_reduce($, function ($, $) { return $ + $["num"]; }); } public function getLastByName($, $) { $ = $this->_analysisUnit->getUnitID($); if ($ == 0) { return array(); } $ = array(); $ = array(); foreach ($ as $ => $) { $[] = "unit_id=:unit_id AND ua=:ua" . $; $["ua" . $] = $; $[] = 1; $[] = "ts DESC"; } $["unit_id"] = $; $ = $this->_table->union($, $, $, $); if (empty($)) { return array(); } return $; } public function getLastByNames($) { $ = $this->_analysisUnit->getUnitIDs($); if (empty($)) { return array(); } $ = array(); $ = array(); $ = array(); foreach ($ as $ => $) { $[] = "unit_id=:unit_id" . $; $["unit_id" . $] = $; $[] = "1"; } $ = $this->_table->union($, $, $); return $; } public function getRangeByNames($, $, $) { $ = $this->_analysisUnit->getUnitIDs($); if (empty($)) { return array(); } $ = array(); foreach ($ as $ => $) { if (empty($)) { continue; } $[] = $; } if (empty($)) { return array(); } $ = implode(",", $); $ = $this->_table->select("*", "ts >= :st AND ts < :et AND unit_id in ({$}) ORDER BY ts ASC", array(":st" => $, ":et" => $)); $ = array(); foreach ($ as $) { if (!isset($[$["unit_id"]])) { $[$["unit_id"]] = array($); continue; } $[$["unit_id"]][] = $; } $ = array(); foreach ($ as $ => $) { if (!isset($[$])) { continue; } $[$] = $[$]; } return $; } public function getTodayByNames($) { $ = utils\Time::wpStrToTime(wp_date("Y-m-d")); $ = time(); return $this->getRangeByNames($, $, $); } }