<?php
 namespace imwpf\modules; class Optimizer { private static $enableQueryFieldsOptimize = true; private $optimizeQueryPosition = array(); public static function disableQueryFieldsOptimize() { self::$enableQueryFieldsOptimize = false; } public static function enableQueryFieldsOptimize() { self::$enableQueryFieldsOptimize = true; } public function disableWPJSON() { add_filter('rest_authentication_errors', function () { if (!is_user_logged_in()) { return new \WP_Error(403, 'not allowed'); } }); } public function disableRevision() { add_filter('wp_revisions_to_keep', function () { return 0; }, 10, 0); } public function disableSearch() { add_action('parse_query', function ($, $ = true) { if (is_search() && !is_admin()) { $->is_search = false; $->query_vars['s'] = false; $->query['s'] = false; if ($ == true) { $->is_404 = true; } } }); } public function disableCopy() { add_action("wp_head", function () { echo "<script>window.document.oncopy = function(){return false;}</script>"; }); } public function optimizeQuery($ = array('home', 'tag', 'category', 'admin')) { $this->optimizeQueryPosition = $; add_filter('posts_fields_request', function ($, $) { return $this->limitQueryFields($, $); }, 10, 2); } public function disableScanFullTable() { add_filter('posts_request', function ($) { return $this->disableCalcFoundRows($); }, 10, 1); add_filter('found_posts', function ($, $) { return $this->setFoundPosts($, $); }, 10, 2); add_filter('query', function ($) { return $this->forbidSomeQuery($); }, 1, 1); add_action('init', function () { $this->countPosts(); }, 10, 0); remove_action('transition_post_status', '_update_term_count_on_transition_post_status', 10); add_action('transition_post_status', function ($, $, $) { $this->($, $, $); }, 10, 3); add_action('added_term_relationship', function ($, $, $) { $this->($, $, $); }, 10, 3); add_action('deleted_term_relationships', function ($, $, $) { $this->($, $, $); }, 10, 3); add_filter('views_edit-post', function ($) { $ = "?flush_post_count=1&post_type=post"; if (isset($_GET['cat'])) { $ .= "&cat=" . intval($_GET['cat']); } $["flush"] = "<a href='{$}'>刷新计数</a>"; return $; }); add_filter('views_edit-page', function ($) { $ = "?flush_post_count=1&post_type=page"; $["flush"] = "<a href='{$}'>刷新计数</a>"; return $; }); add_filter('views_edit-topic', function ($) { $ = "?flush_post_count=1&post_type=topic"; $["flush"] = "<a href='{$}'>刷新计数</a>"; return $; }); foreach (get_taxonomies() as $) { add_action("manage_edit-{$}_columns", function ($) { return $this->addColumn($); }, 10, 1); add_filter("manage_{$}_custom_column", function ($, $, $) { return $this->addReturnValue($, $, $); }, 10, 3); } add_action('wp_ajax_flush_count', function () { $this->ajaxFlushCount(); }); } public function limitQueryFields($, $) { if (!$this->shouldOptimize() || !self::$enableQueryFieldsOptimize) { return $; } if (isset($->query['post_type']) && !in_array($->query['post_type'], array('post', 'page'))) { return $; } $ = $GLOBALS['wpdb']->prefix; $ = "{$}posts.ID, {$}posts.post_date, {$}posts.post_title, {$}posts.post_name, {$}posts.guid, {$}posts.post_status, {$}posts.post_excerpt"; return $; } public function disableCalcFoundRows($) { $ = str_replace('SQL_CALC_FOUND_ROWS', '', $); return $; } public function forbidSomeQuery($) { if (strpos($, "SET `count` = 0 WHERE `term_taxonomy_id`") !== false) { return ""; } if (strpos($, 'posts') === false) { return $; } if (strpos($, 'GROUP BY post_status') !== false) { return $; } if (strpos($, 'SQL_CALC_FOUND_ROWS') !== false) { $ = str_replace('SQL_CALC_FOUND_ROWS', '', $); } $ = array("SELECT post_modified_gmt FROM", "SELECT post_date_gmt FROM", "COUNT"); foreach ($ as $) { if (strpos($, $) !== false) { $ = preg_replace("/LIMIT.*/", "", $); $ .= " LIMIT 0"; break; } } return $; } public function setFoundPosts($, $) { if (strpos($->request, 'GROUP') !== false) { $ = preg_replace("/SELECT.*?FROM(.*)GROUP.*/is", "SELECT count(1) FROM \$1", $->request); } else { if (strpos($->request, 'ORDER') !== false) { $ = preg_replace("/SELECT.*?FROM(.*)ORDER.*/is", "SELECT count(1) FROM \$1", $->request); } else { if (strpos($->request, 'LIMIT') !== false) { $ = preg_replace("/SELECT.*?FROM(.*)LIMIT.*/is", "SELECT count(1) FROM \$1", $->request); } else { $ = preg_replace("/SELECT.*?FROM(.*)/is", "SELECT count(1) FROM \$1", $->request); } } } $ = $this->getCacheSQLResult($); return $; } protected function shouldOptimize() { foreach ($this->optimizeQueryPosition as $) { if ($ == 'home' && is_home()) { return true; } else { if ($ == 'tag' && is_tag()) { return true; } else { if ($ == 'category' && is_category()) { return true; } else { if ($ == 'admin' && is_admin()) { return true; } } } } } return false; } protected function getCacheSQLResult($) { $ = "c_" . substr(md5(str_replace(array(" ", "\n", "\r", "\t"), "", $)), 8, 16); $ = json_decode(get_option($), true); if (empty($)) { $ = $GLOBALS["wpdb"]->get_var($); $ = array('c' => $, 'e' => time() + 86400); add_option($, json_encode($), '', 'no'); return $; } if (time() > $["e"]) { register_shutdown_function(function () use($, $) { if (function_exists("fastcgi_finish_request")) { session_write_close(); fastcgi_finish_request(); } $ = $GLOBALS["wpdb"]->get_var($); $ = array('c' => $, 'e' => time() + 86400); update_option($, json_encode($), false); }); } return $["c"]; } public function countPosts() { if (isset($_GET["flush_post_count"])) { $ = isset($_GET["post_type"]) ? $_GET["post_type"] : "post"; $ = _count_posts_cache_key($, "readable"); if (!empty($_GET['cat'])) { $ = intval($_GET['cat']); $this->flushCount($); } else { $ = wp_count_posts($, "readable"); $ = array('c' => $, 'e' => time() + 86400); update_option($, json_encode($), false); wp_cache_set($, (object) $["c"], 'counts'); return; } } return; } public function flushCount($) { if (!$) { return; } $ = intval($); $ = $GLOBALS["wpdb"]->get_var("SELECT count(1) FROM {$GLOBALS["wpdb"]->prefix}term_relationships WHERE term_taxonomy_id={$}"); return $GLOBALS["wpdb"]->query("UPDATE {$GLOBALS["wpdb"]->prefix}term_taxonomy SET `count`= {$} WHERE term_taxonomy_id={$}"); } public function ajaxFlushCount() { if (isset($_GET['cat'])) { $ = intval($_GET['cat']); if ($this->flushCount($) > 0) { echo '执行成功, 已经更新!'; } else { echo '无更新!'; } } die; } public function addColumn($) { $['flush'] = '刷新计数'; return $; } public function addValue($, $) { if ($ == 'flush') { $ = admin_url(); echo "<a href='{$}admin-ajax.php?action=flush_count&cat={$}' target='_blank'>刷新</a>"; } } public function addReturnValue($, $, $) { if ($ == 'flush') { $ = admin_url(); $ = "<a href='{$}admin-ajax.php?action=flush_count&cat={$}' target='_blank'>刷新</a>"; } return $; } public function disableThumbnails() { add_action('intermediate_image_sizes_advanced', function ($) { unset($['thumbnail']); unset($['medium']); unset($['large']); unset($['medium_large']); unset($['1536x1536']); unset($['2048x2048']); return $; }); add_filter('big_image_size_threshold', '__return_false'); add_action('init', function () { remove_image_size('post-thumbnail'); remove_image_size('another-size'); }); } private function ($, $, $) { static $ = false; if ($) { return; } if ($ == $) { return; } $ = $this->($->ID); if (!$) { return; } $ = $GLOBALS['wpdb']->prefix; if ($ == 'publish' && $ != 'publish') { foreach ($ as $) { $GLOBALS["wpdb"]->query("UPDATE {$}term_taxonomy SET count=count+1 WHERE term_taxonomy_id={$->term_taxonomy_id}"); } $ = true; return; } if ($ != 'publish' && $ == 'publish') { foreach ($ as $) { $GLOBALS["wpdb"]->query("UPDATE {$}term_taxonomy SET count=count-1 WHERE term_taxonomy_id={$->term_taxonomy_id}"); } $ = true; return; } } private function ($) { $ = $GLOBALS['wpdb']->prefix; return $GLOBALS["wpdb"]->get_results("SELECT term_taxonomy_id FROM {$}term_relationships WHERE object_id={$}"); } private function ($, $, $) { static $ = false; if ($) { return; } $ = $GLOBALS['wpdb']->prefix; $ = $GLOBALS["wpdb"]->get_var("SELECT `post_status` FROM {$}posts WHERE `ID`={$}"); if ($ != 'publish') { return; } $ = true; return $GLOBALS["wpdb"]->query("UPDATE {$}term_taxonomy SET `count`=`count`+1 WHERE term_taxonomy_id={$}"); } private function ($, $, $) { static $ = false; if ($) { return; } $ = $GLOBALS['wpdb']->prefix; $ = $GLOBALS["wpdb"]->get_var("SELECT `post_status` FROM {$}posts WHERE `ID`={$}"); if ($ != 'publish') { return; } foreach ($ as $) { if (!$) { continue; } $GLOBALS["wpdb"]->query("UPDATE {$}term_taxonomy SET `count`=`count`-1 WHERE term_taxonomy_id={$}"); } $ = true; return; } }