<?php
 namespace imwpf\modules\db; abstract class Base { public abstract function getTableName(); public abstract function getScheme(); public abstract function getKeys(); public abstract function getPrimaryKey(); public abstract function getUniqueKeys(); public abstract function getSortKey(); protected $__Connection = null; protected $enableException = false; public function __construct(\PDO $) { $this->__Connection = $; } public function isConnected() { return $this->__Connection !== null; } public function enableException() { $this->enableException = true; } public function disableException() { $this->enableException = false; } public function insert($, $ = null) { $ = $ ? $ : $this->getTableName(); $ = array(); foreach ($this->getScheme() as $ => $) { if (empty($[$]) && $ == $this->getPrimaryKey()) { continue; } if (stripos($, 'not null') === false && stripos($, 'default') === false) { if (stripos($, 'int') === false) { $ = isset($[$]) ? $[$] : 0; } else { $ = isset($[$]) ? $[$] : ''; } $[$] = $; } else { if (!isset($[$])) { continue; } } $[$] = $[$]; } $ = array_keys($); $ = str_replace(":", "", '`' . implode('`, `', $) . '`'); $ = ":" . implode(",:", $); $ = str_replace("::", ":", $); $ = array(); foreach ($ as $ => $) { if (strpos($, ':') === false) { $[':' . $] = $; } else { $[$] = $; } } $ = $this->__Connection->prepare("INSERT INTO {$}({$}) VALUES({$})"); $ = $->execute($); $this->errorHandle($); return $; } public function update($, $, $ = array()) { $ = explode("=", $); if (count($) < 2 || $[1] == '') { throw new \Exception("where 条件不允许为空", 1); } $ = array(); foreach ($this->getScheme() as $ => $) { if ($ == $this->getPrimaryKey()) { continue; } if (!isset($[$])) { continue; } $[$] = $[$]; } $ = array(); $ = ''; foreach ($ as $ => $) { $ .= " `{$}`=:{$},"; if (strpos($, ':') === false) { $[':' . $] = $; } else { $[$] = $; } } if (!empty($)) { foreach ($ as $ => $) { if (strpos($, ':') === false) { $[':' . $] = $; } else { $[$] = $; } } } $ = rtrim($, ','); $ = $this->getTableName(); $ = "UPDATE `{$}` SET {$} WHERE {$}"; $ = $this->__Connection->prepare($); $->execute($); $this->errorHandle($); return $->rowCount(); } public function increment($, $, $, $) { $ = explode("=", $); if (count($) < 2 || $[1] == '') { throw new \Exception("where 条件不允许为空", 1); } if ($ == $this->getPrimaryKey()) { throw new \Exception("不允许递增主键", 1); } $ = false; foreach ($this->getScheme() as $ => $) { if ($ == $) { $ = true; break; } } if (!$) { throw new \Exception("key: {$}不存在", 1); } $ = array(); if (!empty($)) { foreach ($ as $ => $) { if (strpos($, ':') === false) { $[':' . $] = $; } else { $[$] = $; } } } $ = $this->getTableName(); $ = intval($); $ = $this->getVar("count(*)", $, $); if ($ > 0) { $ = $this->__Connection->prepare("UPDATE `{$}` SET {$}={$}+{$} WHERE {$}"); $->execute($); $this->errorHandle($); return $->rowCount(); } $ = array($ => $); if (!empty($)) { foreach ($ as $ => $) { if (strpos($, ':') === false) { $[$] = $; } else { $ = ltrim($, ":"); $[$] = $; } } } return $this->insert($); } public function delete($, $ = array()) { $ = $this->getTableName(); $ = $this->__Connection->prepare("DELETE FROM {$} WHERE {$}"); $->execute($); $this->errorHandle($); return $->rowCount(); } public function select($, $, $, $ = '', $ = '') { $ = $this->getTableName(); if (is_array($)) { $ = '`' . implode('`,`', $) . '`'; } $ = "SELECT {$} FROM {$} WHERE {$}"; if ($) { $ .= " ORDER BY {$}"; } if ($) { $ .= " LIMIT {$}"; } $ = $this->__Connection->prepare($); $->execute($); $this->errorHandle($); return $->fetchAll(\PDO::FETCH_ASSOC); } public function get($, $) { return $this->getVars('*', $, $); } public function getVar($, $, $) { $ = $this->getVars($, $, $); if ($) { return $[$]; } else { return false; } } public function getVars($, $, $, $ = null) { if (is_array($)) { $ = '`' . implode('`,`', $) . '`'; } $ = $this->select($, $, $, $, 1); return isset($[0]) ? $[0] : false; } public function selectIn($, $, $) { $ = rtrim(str_repeat('?,', count($)), ','); $ = "`{$}` in ({$})"; return $this->select($, $, $); } public function union(array $, array $, array $ = array(), array $ = array(), $ = '*') { $ = count($); $ = $this->getTableName(); $ = ''; for ($ = 0; $ < $; $++) { $ .= "SELECT {$} FROM (SELECT {$} FROM `{$}` WHERE {$[$]}"; if ($) { $ .= " ORDER BY {$[$]}"; } if ($) { $ .= " LIMIT {$[$]}"; } $ .= ') as t UNION ALL '; } $ = rtrim($, 'UNION ALL '); $ = $this->__Connection->prepare($); $->execute($); $this->errorHandle($); return $->fetchAll(\PDO::FETCH_ASSOC); } public function unionSelect($, $, $, $, $) { $ = count($); $ = $this->getTableName(); $ = ''; for ($ = 0; $ < $; $++) { $ .= "SELECT {$} FROM (SELECT {$} FROM `{$}` WHERE {$[$]}"; if ($) { $ .= " ORDER BY {$[$]}"; } if ($) { $ .= " LIMIT {$[$]}"; } $ .= ') as t UNION ALL '; } $ = rtrim($, 'UNION ALL '); $ = $this->__Connection->prepare($); $->execute($); $this->errorHandle($); return $->fetchAll(\PDO::FETCH_ASSOC); } public function errorHandle(\PDOStatement $) { $ = $->errorInfo(); if ($[2] && $this->enableException) { throw new \Exception($[2], 1); } } public function truncate() { return $this->__Connection->query("TRUNCATE TABLE " . $this->getTableName()); } public function lastInsertId() { return $this->__Connection->lastInsertId(); } public function getVersion() { return 0; } public function hasUpdate() { $ = get_option("table_version_" . $this->getTableName()); return $this->getVersion() > $; } }