<?php
 namespace imwpf\modules\http; abstract class HTTP { private $url = ""; private $timeout = 30; private $requestHeader = array(); private $responseRawHeader = ""; private $responseHeader = array(); private $requestCookie = ""; private $method = "GET"; private $realURL = ""; private $_proxy; private $_proxyType; private $postData; private $error = ""; private $_redirection = true; private $_proxyAuth = ""; private $_authName = ""; private $_authPass = ""; public abstract function exec(); public static function get($, $ = 30) { $ = new static(); $->setURL($); $->setTimeout($); $->method = "GET"; return $; } public static function post($, $, $ = 30) { $ = new static(); $->setURL($); $->setPostData($); $->setTimeout($); $->method = "POST"; return $; } public static function head($, $ = 30) { $ = new static(); $->setURL($); $->setTimeout($); $->method = "HEAD"; return $; } public static function json($, $, $ = 30) { $ = json_encode($); $ = self::post($, $, $); $->setRequestHeader(array('Content-Type: application/json; charset=utf-8', 'Content-Length: ' . strlen($))); return $; } public static function text($, $, $ = 30) { $ = self::post($, $, $); $->setRequestHeader(array('Content-Type: text/plain; charset=utf-8', 'Content-Length: ' . strlen($))); return $; } public function isGET() { return $this->method == "GET" ? true : false; } protected function isPOST() { return $this->method == "POST"; } protected function isHEAD() { return $this->method == "HEAD"; } public function getRealURL() { return $this->realURL; } public function setURL($) { $this->url = $; return $this; } public function setTimeout($) { $this->timeout = $; return $this; } public function setPostData($) { $this->postData = $; return $this; } public function setRequestHeader(array $) { $this->requestHeader = array_merge($this->requestHeader, $); return $this; } public function getResponseHeader() { return $this->responseHeader; } public function setRequestCookie($) { $this->requestCookie = $; return $this; } protected function getRequestCookie() { return $this->requestCookie; } public function setHTTPProxy($, $) { $this->_proxy = $; $this->_proxyType = "http"; $this->_proxyAuth = $; return $this; } public function setSocks4Proxy($, $) { $this->_proxy = $; $this->_proxyType = "socks4"; $this->_proxyAuth = $; return $this; } public function setSocks5Proxy($, $) { $this->_proxy = $; $this->_proxyType = "socks5"; $this->_proxyAuth = $; return $this; } public function setAuth($, $) { $this->_authName = $; $this->_authPass = $; return $this; } public function getAuth() { if (empty($this->_authName)) { return ""; } return $this->_authName . ':' . $this->_authPass; } public function getError() { return $this->error; } public function setProxy($) { $ = parse_url($); if (empty($["scheme"]) || empty($["host"]) || empty($["port"])) { return $this; } $ = ""; if (!empty($["user"])) { $ = $["user"] . ":" . $["pass"]; } if ($["scheme"] == "http") { $this->setHTTPProxy($["host"] . ":" . $["port"], $); } else { if ($["scheme"] == "socks4") { $this->setSocks4Proxy($["host"] . ":" . $["port"], $); } else { if ($["scheme"] == "socks5") { $this->setSocks5Proxy($["host"] . ":" . $["port"], $); } } } return $this; } public function useDefaultRequestHeader() { $this->requestHeader = array("Pragma: no-cache", "Cache-Control: no-cache", "User-Agent: Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/87.0.4280.141 Safari/537.36", "Accept: text/html,application/xhtml+xml,application/xml;q=0.9,image/avif,image/webp,image/apng,*/*;q=0.8,application/signed-exchange;v=b3;q=0.9", "Accept-Language: zh-CN,zh;q=0.9"); return $this; } public function setRedirection($) { $this->_redirection = $; return $this; } protected function _getRedirection() { return $this->_redirection; } protected function getProxy() { return array('proxy' => $this->_proxy, 'type' => $this->_proxyType, 'auth' => $this->_proxyAuth); } public function getResponseRawHeader() { return $this->responseRawHeader; } public function setResponseHeader($) { $this->responseRawHeader = $; $this->responseHeader = $this->($); } private function ($) { $ = array_filter(explode("\r\n", $)); if (count($) == 0) { return array(); } $ = array(); if (preg_match("#http/[0-9\\.]+\\s+([0-9]+)\\s+((\\w|\\s)+)#i", $[0], $)) { $['code'] = intval($[1]); $['msg'] = $[2]; } foreach ($ as $ => $) { $ = explode(':', $, 2); if (isset($[1])) { $ = strtolower(trim($[0])); $ = strtolower(trim($[1])); if (isset($[$])) { if (!is_array($[$])) { $[$] = array($[$]); } $[$][] = $; } else { $[$] = $; } } else { $[] = $; } } if (isset($['content-type'])) { $ = $["content-type"]; if (!is_array($["content-type"])) { $ = array($["content-type"]); } foreach ($ as $) { if (strpos($, 'charset') !== false) { $ = substr($, strpos($, 'charset') + 8); $['charset'] = $; break; } } } return $; } protected function setRealURL($) { $this->realURL = $; } protected function getURL() { return $this->url; } protected function getPostData() { return $this->postData; } protected function getTimeout() { return $this->timeout; } protected function getRequestHeader() { return $this->requestHeader; } protected function setError($) { $this->error = $; } }